<style type="text/css" scoped="">
.page_ct{
  display: flex;
  margin-top: 30px;
  margin-bottom: 18px;
  justify-content: center;
}
.base_table{
  margin-top: 20px;
}
</style>
<template>
  <div class="product_list pane_ct">

    <div class="manage_pane_nav">
      <h2 class="manage_pane_nav_title">商品管理</h2>
      <div class="manage_pane_actions">
        <a href="javascript:;" class="action_btn" @click="visible('add_product_form_config', true)">添加商品</a>
      </div>
    </div>

    <!-- <base_dialog></base_dialog> -->
    <msg_to_chain v-if="msg_to_chain_config.show" :data="msg_to_chain_config.data" @close="toggle_msg_to_chain(false)"></msg_to_chain>

    <div>
      <table class="base_table">
        <tr class="header">
          <td>
            <div class="small_gray_ft">
              商品图片
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              商品名称/规格
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              品牌
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              商品编码
            </div>
          </td>
          <td>
            <div class="small_gray_ft">
              操作
            </div>
          </td>
        </tr>

        <tr v-for="item, index in query_configs.data" :key="index" @click="to_sku_manage(item)">
          <td @click.stop="">
              <div class="img_ct" @click.stop="show_img(index, true)" :style="get_bg(item.goodsPic)"></div>
              <img_show_dialog v-if="item.show_img" v-model="item.goodsPic" @close="show_img(index, false)"></img_show_dialog>
          </td>
          <td>
              <router-link :to="{'name': 'product_sku_manage', params: {'goods_id': item.goodsId, 'goods_name': item.goodsName, 'goods_code': item.goodsCode}}">
                {{ item.goodsName }}  
              </router-link>
          </td>
          <td>
              {{ item.goodsBrand }}
          </td>
          <td>
              {{ item.goodsCode }}
          </td>
          <td>
              <div class="td_actions_ct">
                <a class="td_action_btn" href="javascript:;" @click.stop="start_edit(item)">修改</a>
                <a class="td_action_btn"  href="javascript:;" @click.stop="delete_goods(item)" v-if="!item.delete_on_load">删除</a>
                <a class="td_action_btn"  href="javascript:;" v-if="item.delete_on_load">删除...</a>
              </div>
          </td>
        </tr>
      </table>

      <div class="no_data flex_center" v-if="!query_configs.on_load && !query_configs.data.length">
        当前无记录
      </div>

      <div class="flex_center" v-if="query_configs.on_load && !query_configs.data.length">
        <load_area :on_load="query_configs.on_load" :btn_text="query_configs.btn_text" :circle_class="query_configs.circle_class"></load_area>
      </div>

      <!-- <div class="page_ct">
        <div class="td_action_btn ">上一页</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn blue_aciton_btn">1</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn base_btn">1</div>
        <div class="td_action_btn ">下一页</div>
      </div> -->

      <page_foot 
      :total="query_configs.total_page" 
      :current="query_configs.params.pageNum"
      v-if="query_configs.total_page > 0"
      @select="select"
      ></page_foot>

    </div>

    <add_product_form 
    v-if="add_product_form_config.visible" 
    @close="visible('add_product_form_config', false)"
    @success="add_item_success"
    ></add_product_form>
    <edit_product_form 
    v-if="edit_product_form_config.visible" 
    v-model="edit_product_form_config.data"
    @success="edit_item_success"
    @close="visible('edit_product_form_config', false)"
    ></edit_product_form>
  </div>
</template>
<script>
import add_product_form from '@/modules/admins/product_manage/add_product_form.vue'
import edit_product_form from '@/modules/admins/product_manage/edit_product_form.vue'
import img_show_dialog from '@/modules/admins/img_show_dialog.vue'
import msg_to_chain from '@/modules/admins/product_manage/msg_to_chain_dialog.vue'
import load_area from '@/components/load_area.vue'

import page_foot from '@/modules/admins/page_foot.vue'

import {
  query_goods,
  query_goods_page,
  delete_goods
} from '@/service'
import {
  get_token
} from '@/modules/stores'
import {
  wait_time
} from '@/modules/utils'
export default {
  data () {
    return {
      add_product_form_config: {
        visible: false
      },

      edit_product_form_config: {
        visible: false,
        data: null
      },

      query_configs: {
        on_load: false,
        circle_class: 'global_load_circle',
        total_page: 1,
        params: {
          'pageNum': 1,
        },
        data: [],
        msg: ''
      },

      msg_to_chain_config: {
        show: false,
        data: null
      }
    }
  },
  mounted () {
    this.query();
  },
  methods: {
    visible (config, status){
      this[config].visible = status;
    },
    select (page) {
      this.query_configs.params.pageNum = page;
      this.query();
    },
    async query () {
      await this.query_page();
      let params = JSON.parse(JSON.stringify(this.query_configs.params));
      params.userName = get_token('user_name')

      this.query_configs.on_load = true;

      let data = await query_goods(params);
      this.query_configs.data.splice(
        0, 
        this.query_configs.data.length, 
        ...(data.data || [])
      );
      this.query_configs.on_load = false;

      this.query_configs.total_page = data.pageNum;
    },
    async query_page () {
      let data = await query_goods_page(this.query_configs.params);
      this.query_configs.total_page = data.pageNum;
    },
    start_edit (item) {
      this.edit_product_form_config.data = item;
      this.visible('edit_product_form_config', true);
    },
    async edit_item_success (item) {
      let index = this.query_configs.data.findIndex(i => i.goodsId == item.goodsId);
      if(index > -1){
        this.query_configs.data.splice(index, 1, item);
      }else{
        this.query_configs.data.unshift(item);
      }
      this.visible('edit_product_form_config', false);
      this.visible('add_product_form_config', false);
      await this.query_page();
    },
    async add_item_success (item) {
      await this.edit_item_success(item);
      this.toggle_msg_to_chain(true, item);
    },
    async delete_goods (item) {
      let confirm_delete = confirm('确定删除当前产品？');
      if(!confirm_delete) return ;
      let index = this.query_configs.data.findIndex(i => i.goodsId == item.goodsId);
      item.delete_on_load = true;
      this.query_configs.data.splice(index, 1, item);

      let {errCode, errMsg} = await delete_goods({goodsId: item.goodsId});
      if(errCode != 200){
        item.delete_on_load = false;
        this.query_configs.data.splice(index, 1, item);
        alert(errMsg);
        return ;
      }
      this.query_configs.data.splice(index, 1);
    },
    to_sku_manage (item) {
      this.$router.push({
        'name': 'product_sku_manage', 
        params: {
          'goods_id': item.goodsId, 
          'goods_name': item.goodsName, 
          'goods_code': item.goodsCode
        }
      });
    },
    show_img (index, status){
      this.query_configs.data[index].show_img = status;
      let item = this.query_configs.data[index];
      let data = this.query_configs.data.splice(index, 1, item);
    },
    get_bg (url) {
      return {
        'backgroundImage': `url(${url})`
      }
    },
    toggle_msg_to_chain (status, data) {
      this.msg_to_chain_config.show = status;
      this.msg_to_chain_config.data = data;
    }
  },
  components: {
    add_product_form,
    edit_product_form,
    img_show_dialog,
    msg_to_chain,
    load_area,
    page_foot
  }
}
</script>